/************************************************/
/* FstEUser.h .. header file used by FastUser.c */
/* the listed header files  must be on the same */
/* disk as the compiler                         */
/************************************************/

#include <string.h>
#include <qd.h>
#include <misc.h>
#include <mem.h>
#include <win.h>
#include <qdvars.h>
#include <control.h>
#include <te.h>
#include <event.h>
#include <file.h>
#include <seg.h>
#include <pack.h>
#include <menu.h>
#include <dialog.h>
#include <toolbox.h>

#define TRUE      1
#define FALSE     0

#define OK        1
#define ERR       0

#define NEXT      1
#define PRVS      0

#define WORD      1
#define STRING    0

#define MMC       1
#define AZTEC     2

#define STR_LNGTH       256
#define LINE_LNGTH      81
#define MAX_FLS_PASSED  16

#define AUTOKEY   -1
#define NONE      -1
#define BREAK     -1
#define NULL       0
#define CRONLY    -1    /* (*te_hndl)->cronly == CRONLY if word wrap off */

#define NIL        0L
#define SCROLL    -1L
#define SCAN_CR   -1L   /* for index_wild .. scan till CR */

#define APPLE_MRK 0X14
#define ENTER     0X03
#define CR        0X0d  /* carriage return      */
#define TAB       0X09 
#define BKSP      0X08  /* backspace            */
#define BULLET    0XA5

#define DOT_KEY   47
#define COMMA_KEY 43
#define ZERO_KEY  29
#define ONE_KEY   18
#define TWO_KEY   19
#define THREE_KEY 20
#define FOUR_KEY  21
#define FIVE_KEY  23
#define SIX_KEY   22
#define SEVEN_KEY 26
#define EIGHT_KEY 28
#define NINE_KEY  25
#define A_KEY      0
#define B_KEY     11
#define C_KEY      8
#define D_KEY      2
#define E_KEY     14
#define F_KEY      3
#define G_KEY      5
#define H_KEY      4
#define I_KEY     34
#define J_KEY     38
#define K_KEY     40
#define L_KEY     37
#define M_KEY     46
#define N_KEY     45
#define O_KEY     31
#define P_KEY     35
#define Q_KEY     12
#define R_KEY     15
#define S_KEY      1
#define T_KEY     17
#define U_KEY     32
#define V_KEY      9
#define W_KEY     13
#define X_KEY      7
#define Y_KEY     16
#define Z_KEY      6

/************************************************************/
/* menu headers and menu items .. FastUser() can access     */
/* menus facilities with menu_choise (menu_head, menu_item) */
/************************************************************/
#define APPLE     1 
#define   ABOUT         1
#define   ABOUT_FILE    2 
#define FILE      2 
#define   NEW           1
#define   OPEN          2
#define   KLOSE         3 
#define   DELETE        4 
#define   SAVE          6
#define   SAVE_TO       7
#define   REVERT        9
#define   QUIT         11
#define   TRANSFER     12
#define EDIT      3 
#define   UNDO          1 
#define   CUT           3 
#define   COPY          4 
#define   PASTE         5
#define   CPY_PST_0     7
#define   CPY_PST_1     8
#define   CPY_PST_N     9
#define   CPY_PST_9    10
#define SEARCH    4 
#define   FIND          1 
#define   GLOSS         2
#define   BALANCE       3 
#define   LINE          4
#define   IMPSBLS       5
#define   COMPARE       6
#define DISPLAY   5
#define   MOVE          1
#define   NEAT          2
#define   REVERSE       3
#define   JUSTIFY       4
#define WINDOWS   6
#define FONT      7
#define SIZE      8
#define OPTIONS   9
#define   INSERT        1  
#define   SYNC          2  
#define   FIND_GLOBAL   4  
#define   FIND_SENS     5  
#define   WRAP          7
#define   AUTO_IN       8
#define   AUTO_GLOSS    9
#define   OPEN_FULL    10
#define   AUTO_SAVE    11
#define   TAB_SET      12
#define   SMART        13
#define   SV_OPTIONS   15

#define K_MENUS 9

/************************************************************/
/* each FastEddie window has an associated node with the    */
/* following fields:                                        */
/************************************************************/
typedef struct win_node
  { char                title [LINE_LNGTH],     /* file title                 */
                        win_title [LINE_LNGTH]; /* window title               */
    windowpeek          wpeek;                  /* unused                     */
    windowptr           wp;                     /* window pointer             */
    rect                *pr;                    /* the port rectangle         */
    tehandle            te_hndl;                /* see IM TextEdit            */
    controlhandle       scrl_hndl;              /* see IM Control Manager     */
    int                 h_scrl,                 /* horizontal scroll position */
                        strokes,                /* strokes since save         */
                        vref,                   /* see IM File Manager        */
                        slot,                   /* home position of window    */
                        moved,                  /* if window moved from home  */ 
                        left, top, right, bottom; /* original window position */
    int                 part_nmbr, nmbr_parts;  /* of multiple part file      */
    long                strt_pos, orig_lngth;   /* used by Revert             */
    struct win_node     *nxt_node;              /* of multi part file */
  };
