/******************************************************************/
/* FastUser.. Source file for user code to be linked into         */
/* FastEddie2 with Megamax C compiler & linker.  Change it,       */
/* add to it, delete unused functions ... then compile it and     */
/* link the resulting object file with FstE.lib into FastEddie2   */
/*                                                                */
/* FastUser() is called by <cmd><Option>key or if menu_choice()   */
/* sees a user created menu_item.                                 */
/*                                                                */
/* the menu item SEARCH COMPARE is herein defined                 */
/*                                                                */
/* the following <cmd><Option> functions are herein defined:      */
/*    F: to access <cmd><Option>F facilities of Find, change ...  */ 
/*    C: close all open files:                                    */
/*    Q: quit and exit with status dependant on modifier  keys    */
/*    cursor movement by keystroke routines U I O J L M , .       */
/*    T: insert the time day, or date                             */
/*    W: revolve windows                                          */
/******************************************************************/
#include "FastUser.h"
overlay "UserCode"

FastUser (menu_head, menu_item)
int   menu_head, menu_item;
{
  extern eventrecord    event;
  extern menuhandle     menus[];
  extern int            auto_in, auto_gloss, 
                        find_global, find_sens;

  char                  *strcpy(), *month_name(), *day_name();
  struct win_node       *node, *nxt_node;
  windowptr             win_ptr, nxt_win();
  tehandle              te_hndl;
  long                  refcon, selstart, selend, lngth;
  int                   i, j, kind, status;
  char                  str [STR_LNGTH], *text, key, 
                        *argv [MAX_FLS_PASSED];
  datetimerec           date;

  key = menu_item;            /* an alias for clarity when menu_head == 0 */
  win_ptr = frontwindow();
  if (!win_ptr) kind = FALSE;
  else kind = ( (windowpeek) win_ptr)->windowkind;
  if (kind == userkind)
    { refcon = ( (windowpeek) frontwindow() )->refcon;
      node = (struct win_node *) refcon;
      te_hndl = node->te_hndl;  
      text = *(*te_hndl)->htext; 
      selstart = (*te_hndl)->selstart;    
      selend = (*te_hndl)->selend;
      lngth = (*te_hndl)->telength;
    }

/********************************************************************/
/* when menu_choice (menu_head, menu_item) cannot find  code        */
/* for menu_item it calls FastUser (menu_head, menu_item):          */
/* SEARCH COMPARE below is an example of how to associate           */
/* code with a created menu item (COMPARE is not in menu_choice() ) */
/********************************************************************/

if (menu_head > 0)
  {
    switch (menu_head)
      {
        case FILE:
          /********************************************************/
          /* any menu items in the FILE menu past TRANSFER        */
          /* is presumed to have been added for direct transfer   */
          /* to  an application on the default disk ..            */
          /* use ResEdit to create the transfers of your choise   */
          /********************************************************/
            getitem (menus [FILE], menu_item, str);
            close_all (TRANSFER, str);
            break;

        case SEARCH:
           switch (menu_item)
             { 
               case COMPARE:  /* see cmpr() code below            */
                 cmpr();  break;
      
               /***************************************************/
               /* other "case <menu item>:" statements go here    */
               /***************************************************/
             }

        /**************************************************/
        /* other "case <menu header>:" statements go here */
        /**************************************************/
      }                       /* end "switch (menu_head)"         */
    return TRUE;
  }



/********************************************************/
/* when <cmd><Option>key is pressed FastUser is called  */ 
/* with menu_head == 0, and the following code pertains */
/********************************************************/

  switch (key)
    {

/******************************/
/* W: revolve windows:        */ 
/*    <Shift> to reverse      */
/******************************/
      case W_KEY:
        win_ptr = frontwindow();
        if (event.modifiers & shiftkey)
          { if ( (win_ptr = nxt_win (win_ptr, PRVS) )  ) 
              selectwindow (win_ptr);
          }
        else 
          if (nxt_win (win_ptr, NEXT) )  
            sendbehind (win_ptr, NIL);
        break;


/*******************************************************/
/* F: to access <cmd><Option>F facilities of find:  */ 
/*******************************************************/
      case F_KEY:
        if (menu_head == AUTOKEY || kind != userkind) break;
        menu_choice (SEARCH, FIND);  break;


/******************************/
/* C: close all open files:   */
/******************************/
      case C_KEY:
        if (menu_head == AUTOKEY) break;
        close_all (0, "");  break;


/******************************************************/
/* Q: quit and exit with status dependant             */
/*    on modifier  keys (normal exit status is 0):    */
/*          if <Option>   add 1                       */
/*          if <Shift>    add 2                       */
/*          if <CapsLock> add 4                       */
/******************************************************/
       case Q_KEY:
        if (menu_head == AUTOKEY) break;
         status = 1;
         if (event.modifiers & shiftkey)  status += 2;
         if (event.modifiers & alphalock) status += 4;
         if (close_all (0, "") ) exit (status);
         break;


/************************************************************/
/* cursor movement by keystroke routines:                   */
/*    <Shift> extends selection                             */
/*    nested switch avoids repetition, saves space          */
/*    punct_char (ch) returns TRUE if ch is punctuation:    */
/*          CR TAB SPACE . , ! ? ' : ; " ( ) [ ] < >        */
/************************************************************/

      case J_KEY:
      case L_KEY:
      case COMMA_KEY:
      case I_KEY:
      case M_KEY:
      case DOT_KEY:
      case U_KEY:     
      case O_KEY:
        if (kind != userkind) break;
        switch (key)
          {
            case J_KEY:   /* left a space */
              if (selstart >= 0) selstart--;
              if (!(event.modifiers & shiftkey) ) selend = selstart;
              break;
      
            case L_KEY:   /* right a space */
              if (selend < lngth) selend++;
              if (!(event.modifiers & shiftkey) ) selstart = selend;
              break;
        
            case COMMA_KEY:   /* down a line */
              for (i = 0; text [selend - 1] != CR && selend > 0; i++, selend--);
              while (text [selend] != CR && selend + i < lngth) selend++;
              for (j = 0; j < i + 1 && text [++selend] != CR; j++);
              if (!(event.modifiers & shiftkey) ) selstart = selend;
              break;
      
            case I_KEY:   /* up a line */
              for (i = 0; text [--selstart] != CR && selstart; i++);
               while (selstart >= 0 && text [--selstart] != CR);
               for (j = 0; j <= i && text [++selstart] != CR; j++);
              if (!(event.modifiers & shiftkey) ) selend = selstart;
              break;
            
            case M_KEY:   /* back a word */
              selstart--;
              while ( selstart > 0 && 
                      ( !punct_char (text [selstart - 1]) ||
                        punct_char (text [selstart])
                    ) ) selstart--;
              if (!(event.modifiers & shiftkey) ) selend = selstart;
              break;
            
            case DOT_KEY:     /* forward a word */
              selend++;
              while ( selend < lngth && 
                      ( !punct_char (text [selend]) ||
                        punct_char (text [selend - 1])
                    ) ) selend++;
              if (!(event.modifiers & shiftkey) ) selstart = selend;
              break;

            case U_KEY:   /* beginning of line */
              selstart--;
              while ( selstart > 0 && 
                      ( text [selstart - 1] != CR
                    ) )  selstart--;
              if (!(event.modifiers & shiftkey) ) selend = selstart;
              break;           
            
            case O_KEY:   /* end of line */
              selend++;
              while ( selend < lngth && 
                      ( text [selend] != CR
                    ) ) selend++;
              if (!(event.modifiers & shiftkey) ) selstart = selend;
              break;
          }             /* end switch (key)     */

        sel_scroll (selstart, selend, node);
        break;          /* end cursor movement  */



/******************************************************/
/* T: insert the time if <Shift> && <CapsLock>        */
/*    else if <Shift> insert the day                  */
/*    else insert the date                            */
/*                                                    */
/* if the frontwindow is not a FastEddie window quit; */
/* else get the date string (see gettime in IM),      */
/* extract and format the appropriate data            */
/******************************************************/
      case T_KEY:
        if (menu_head == AUTOKEY || kind != userkind) break;
        gettime (&date);
        node->strokes++;

        if ( (event.modifiers & shiftkey) &&
             (event.modifiers & alphalock)
           )
          { date.hour  = 100 * date.hour + date.minute;
            if (date.hour < 100) date.hour += 2400;
            itoa ( (long) date.hour, str);
            if (date.hour > 2399) str [0] = str [1] = '0';
            if (date.hour < 1000)
              { str [5] = '\0';
                str [4] = ' ';
                str [3] = str [2];
                str [2] = str [1];
                str [1] = ':';
                teinsert (str, 5L, te_hndl);
              }
            else
              { str [6] = '\0';
                str [5] = ' ';
                str [4] = str [3];
                str [3] = str [2];
                str [2] = ':';
                teinsert (str, 6L, te_hndl);
              }
            break;
          }
        if (event.modifiers & shiftkey)
          { strcpy (str, day_name (date.dayofweek) );
            teinsert (str, (long) strlen (str), te_hndl);
            break;
          }
        strcpy (str, month_name (date.month) );
        teinsert (str, (long) strlen (str), te_hndl);
        itoa ( (long) date.day, str);
        str [2] = ',';                 
        str [3] = ' ';
        itoa ( (long) date.year, str + 4);
        str [8] = ' ';
        teinsert (str, 9L, te_hndl);
        break;


/***********************************************/
/* insert your <cmd><Option>key routines here: */
/***********************************************/

      default: return FALSE;

    }
}
    
/************************************************/
/* cmpr.. compare files                         */
/*    stop at first differerence after selend   */
/*    and select next character ...             */
/*    skip multiple blanks && CR                */
/************************************************/
cmpr()
{
  int             i;
  long            refcon, 
                  lngth1, lngth2, 
                  selstart1, selstart2;
  windowptr       win_ptr;
  struct win_node *node1, *node2;
  char            *text1, *text2;
  

      /****************************************************/
      /* get selstart1, text1 && lngth1 for front window: */
      /****************************************************/
  win_ptr = frontwindow();
  if (win_ptr == NIL ||  ( (windowpeek) win_ptr)->windowkind != userkind)
    return ERR;
  refcon = ( (windowpeek) win_ptr)->refcon;
  node1 = (struct win_node *) refcon;
  selstart1 = (*node1->te_hndl)->selend;
  text1 = *(*node1->te_hndl)->htext;
  lngth1 =  (*node1->te_hndl)->telength;
  
      /****************************************************/
      /* get selstart2, text2 && lngth2 for next window:  */
      /****************************************************/
 win_ptr = ( (windowpeek) win_ptr)->nextwindow;
  if (win_ptr == NIL ||  ( (windowpeek) win_ptr)->windowkind != userkind)
    return ERR;
  refcon = ( (windowpeek) win_ptr)->refcon;
  node2 = (struct win_node *) refcon;
  selstart2 = (*node2->te_hndl)->selend;
  text2 = *(*node2->te_hndl)->htext;
  lngth2 =  (*node2->te_hndl)->telength;


      /************************************************/
      /* skip spaces and CRs .. break on mismatch:    */
      /************************************************/
  for ( i = 0; 
        i + selstart1 < lngth1 && i + selstart2 < lngth2;
        i++
      ) 
    { while ( text1 [selstart1 + i] == ' ' ||
              text1 [selstart1 + i] == CR
            ) selstart1++;
      while ( text2 [selstart2 + i] == ' ' ||
              text2 [selstart2 + i] == CR
            ) selstart2++;
      if (text1 [selstart1 + i] != text2 [selstart2 + i]) break;
    }

      /************************************************************/
      /* select, scroll to, and display the differing characters: */
      /************************************************************/
  sel_scroll (selstart1 + i, selstart1 + i + 1, node1);
  teactivate (node2->te_hndl);
  sel_scroll (selstart2 + i, selstart2 + i + 1, node2);
  teactivate (node1->te_hndl);
  return OK;
} 
